const lo = require('lodash');
const hlp = require('../../../../helpers')

const sections = ['TrustedZonePolicy']
const formValues = ['TrustAllBackupReadOperations', 'TrustedProcessesEnabled', 'TrustedProcesses']

function toView (policiesCache) {
    let data = hlp.customToView(policiesCache.TrustedZonePolicy.Policy.KLPRSS_Val, formValues)
    for(let item of data.TrustedProcesses.KLPRSS_Val[0]){
        item.ModuleHash = ''
        if(item.ExecuteModuleHash!==undefined){
            const hash = item.ExecuteModuleHash.KLPRSS_Val
            item.ModuleHash = (hash.type==='binary') ? Buffer.from(hash.value, 'base64').toString('hex') : ''
        }
    }

    return data
}

function toRaw (changedData, policiesCache) {
    let rules = changedData.TrustedProcesses.KLPRSS_Val[0]
    for(let item of rules){
        if(!item.ExecuteModuleHash)
            item.ExecuteModuleHash = {KLPRSS_Val: {type:'binary', value: ''}}

        const base64 = Buffer.from(item.ModuleHash, 'hex').toString('base64')
        item.ExecuteModuleHash.KLPRSS_Val.value = base64
        item.__VersionInfo = {KLPRSS_Mnd:false, KLPRSS_Val:[1,1]}
        delete item.ModuleHash
    }

    Object.assign(policiesCache.TrustedZonePolicy.Policy.KLPRSS_Val, lo.pick(changedData, formValues) )
}

module.exports = {
    sections,
    toView,
    toRaw
};
