const lo = require('lodash');
const utils = require('../../../../utils');
const hlp   = require('../../../../helpers')
const hlpSchedule = require('../Schedule/schedule.js')

const sections = ['NetworkAttackBlockerPolicy', 'PredefinedTasksPolicy'];
const formCommon = ['BlockAttackOnBoot', 'EnforcementMode'];
const formExcludes = ['UseExcludes', 'ExcludeAddresses'];

function toView (policiesCache) {
    let data = {
        Form_Network_AttackBlocker_Common: hlp.customToView(policiesCache.NetworkAttackBlockerPolicy.Policy.KLPRSS_Val, formCommon),
        Form_Network_AttackBlocker_Excludes: hlp.customToView(policiesCache.NetworkAttackBlockerPolicy.Policy.KLPRSS_Val, formExcludes),
        Form_NetworkAttackBlockerSchedule: hlpSchedule.toView(policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.NetworkAttackBlockerStartOptions)
    }

//    data.Form_Network_AttackBlocker_Excludes.Ips = utils.toViewArray(data.Form_Network_AttackBlocker_Excludes.ExcludeAddresses.KLPRSS_Val[0], 'Ip');
    return data
}

function toRaw (changedData, policiesCache) {
//    changedData.Form_Network_AttackBlocker_Excludes.ExcludeAddresses.KLPRSS_Val[0] = utils.toRawArray(changedData.Form_Network_AttackBlocker_Excludes.Ips,'Ip')

    Object.assign( policiesCache.NetworkAttackBlockerPolicy.Policy.KLPRSS_Val, lo.pick(changedData.Form_Network_AttackBlocker_Common, formCommon));
    Object.assign( policiesCache.NetworkAttackBlockerPolicy.Policy.KLPRSS_Val, lo.pick(changedData.Form_Network_AttackBlocker_Excludes, formExcludes));
    hlpSchedule.toRaw(changedData.Form_NetworkAttackBlockerSchedule, policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.NetworkAttackBlockerStartOptions);
}

module.exports = {
    sections,
    toView,
    toRaw
};
