const lo = require('lodash');
const hlp = require('../../../../helpers')
const hlpSchedule = require('../Schedule/schedule.js')

const sections = ['FirewallPolicy', 'PredefinedTasksPolicy']
const formAppRules = ['ApplicationRules']
const formPortRules = ['OpenPorts']

function toView (policiesCache) {
    let data = {
        Form_Network_FirewallAppRules: hlp.customToView(policiesCache.FirewallPolicy.Policy.KLPRSS_Val, formAppRules),
        Form_Network_FirewallPortRules: hlp.customToView(policiesCache.FirewallPolicy.Policy.KLPRSS_Val, formPortRules),
        Form_Policy_FirewallSchedule: hlpSchedule.toView(policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.FirewallStartOptions)
    }

    return data
}

function toRaw (changedData, policiesCache) {
    let rules = changedData.Form_Network_FirewallAppRules.ApplicationRules.KLPRSS_Val[0]
    for(let item of rules){
        let remoteAddress = item.RemoteAddresses.KLPRSS_Val.trim()
        if(remoteAddress==='')
            remoteAddress = '*'
        item.RemoteAddresses.KLPRSS_Val = remoteAddress
        item.__VersionInfo = {KLPRSS_Mnd:false, KLPRSS_Val:[1,1]}
    }
//    Object.assign( policiesCache.FirewallPolicy.Policy.KLPRSS_Val, lo.pick(changedData, formValues))
    Object.assign( policiesCache.FirewallPolicy.Policy.KLPRSS_Val, lo.pick(changedData.Form_Network_FirewallAppRules, formAppRules));
    Object.assign( policiesCache.FirewallPolicy.Policy.KLPRSS_Val, lo.pick(changedData.Form_Network_FirewallPortRules, formPortRules));
    hlpSchedule.toRaw(changedData.Form_Policy_FirewallSchedule, policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.FirewallStartOptions);
}

module.exports = {
    sections,
    toView,
    toRaw
};
