const lo = require('lodash');
const hlp = require('../../../../helpers');

const sections = ['WebTrafficMonitorPolicy'];
const formValues = ['UseExcludeProcesses','ExcludeProcesses'];


function toView (policiesCache) {
    let data = hlp.customToView(policiesCache.WebTrafficMonitorPolicy.Policy.KLPRSS_Val, formValues);
    data.uiFields = {Apps:[]};
    for(let node of data.ExcludeProcesses.KLPRSS_Val[0]){
        data.uiFields.Apps.push({App:node});
    }

    return data;
}

function toRaw (changedData, policiesCache) {
    let exclApps = [];
    for(let node of changedData.uiFields.Apps){
        exclApps.push(node.App);
    }
    delete changedData.uiFields;
    changedData.ExcludeProcesses.KLPRSS_Val[0] = exclApps;
    Object.assign( policiesCache.WebTrafficMonitorPolicy.Policy.KLPRSS_Val, lo.pick(changedData, formValues));
}

module.exports = {
    sections,
    toView,
    toRaw
};
