const lo = require('lodash');
const hlp = require('../../../../helpers')

const sections = ['WebTrafficMonitorPolicy']
const formValues = ['ExcludedAddresses']

function toView (policiesCache) {
    let data = hlp.customToView(policiesCache.WebTrafficMonitorPolicy.Policy.KLPRSS_Val, formValues)
    data.uiFields = {Ips:[]}
    for(let node of data.ExcludedAddresses.KLPRSS_Val[0]){
        data.uiFields.Ips.push({Ip:node})
    }

    return data
}

function toRaw (changedData, policiesCache) {
    let exclIps = []
    for(let node of changedData.uiFields.Ips){
        exclIps.push(node.Ip)
    }
    delete changedData.uiFields
    changedData.ExcludedAddresses.KLPRSS_Val[0] = exclIps
    Object.assign( policiesCache.WebTrafficMonitorPolicy.Policy.KLPRSS_Val, lo.pick(changedData, formValues))
}

module.exports = {
    sections,
    toView,
    toRaw
};
