const lo = require('lodash');
const hlp = require('../../../../helpers')

const sections = ['WebTrafficMonitorPolicy']
const formValues = ['UseHeuristicAnalyzer','HeuristicAnalyzerLevel',
                    'UseOutlookPlugin', 'EnableWmuf', 'EnableAntiPhishing', 'UseKsn'
]

function toView (policiesCache) {
    let data = hlp.customToView(policiesCache.WebTrafficMonitorPolicy.Policy.KLPRSS_Val, formValues)
    data.UseTz = policiesCache.WebTrafficMonitorPolicy.Policy.KLPRSS_Val.Base.UseTrustedZoneSettings
    return data
}

function toRaw (changedData, policiesCache) {
    Object.assign( policiesCache.WebTrafficMonitorPolicy.Policy.KLPRSS_Val, lo.pick(changedData, formValues))
    policiesCache.WebTrafficMonitorPolicy.Policy.KLPRSS_Val.Base.UseTrustedZoneSettings = changedData.UseTz
}

module.exports = {
    sections,
    toView,
    toRaw
};
