const lo = require('lodash');
const hlp = require('../../../../helpers')
const utilsLI = require('../../../utils/li.js')
const hlpSchedule = require('../Schedule/schedule.js')

const sections = ['LogInspector','PredefinedTasksPolicy']
const formPredefRulesValues = ['UsePredefRules','PredefRules']
const formCustomRulesValues = ['CheckWinEvtLog','WindowsEventLog']

function toView (policiesCache) {
    let data = {
        Form_LogInspect_CustomRules: hlp.customToView(policiesCache.LogInspector.Policy.KLPRSS_Val, formCustomRulesValues),
        Form_LogInspect_PredefinedRules: hlp.customToView(policiesCache.LogInspector.Policy.KLPRSS_Val, formPredefRulesValues),
        Form_LogInspect_Schedule: hlpSchedule.toView(policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.LogInspectorStartOptions)
    }
    data.Form_LogInspect_CustomRules = utilsLI.toViewCustomRules(data.Form_LogInspect_CustomRules);
    data.Form_LogInspect_PredefinedRules = utilsLI.toViewPredefinedRules(data.Form_LogInspect_PredefinedRules);
    return data
}

function toRaw (changedData, policiesCache) {
    // custom rules
    const CustomRules = utilsLI.toRowCustomRules(changedData.Form_LogInspect_CustomRules);
    Object.assign( policiesCache.LogInspector.Policy.KLPRSS_Val, lo.pick(CustomRules, formCustomRulesValues));
    // predefined rules
    const PredefinedRules = utilsLI.toRowPredefinedRules(changedData.Form_LogInspect_PredefinedRules);
    Object.assign( policiesCache.LogInspector.Policy.KLPRSS_Val, lo.pick(PredefinedRules, formPredefRulesValues));
    // schedule
    hlpSchedule.toRaw(changedData.Form_LogInspect_Schedule, policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.LogInspectorStartOptions);

/*
    Object.assign(policiesCache.LogInspector.Policy.KLPRSS_Val, lo.pick(changedData, formValues))
 */
}

module.exports = {
    sections,
    toView,
    toRaw
};
