const lo = require('lodash');
const hlp = require('../../../../helpers')

const sections = ['TrustedZoneSettings']
const formValues = ['ExclutionRules']

function toView (settCache, activePolicyCache) {
    let data = {
        ExclutionRules: hlp.GetMergedLocalSettingsKey(settCache.TrustedZoneSettings,activePolicyCache.TrustedZoneSettings, 'ExclutionRules'),
        LocalSettings:true
    };

    for(let item of data.ExclutionRules.KLPRSS_Val[0]){
        // local settings format
        if( item.ApplyForFileMonitor.KLPRSS_Val===undefined){
            item = hlp.ItemToPolicyView(item);
        }
        item.MasksStr = item.ThreatNameMasks.KLPRSS_Val.join(";");
    }
    return data;
}

function toRaw (changedData, settCache) {
    var re = new RegExp(/^(\s|\u00A0)+/g);
    let rules = changedData.ExclutionRules.KLPRSS_Val[0];
    for(let item of rules){
        let tmp = item.MasksStr.split(';');
        if(item.ThreatNameMasks===undefined)
            item.ThreatNameMasks = {};
        item.ThreatNameMasks.KLPRSS_Val = tmp.filter(function(x){
            return (x !== (undefined || null || ''));
        });

        delete item.MasksStr;
        for(let object of item.Objects.KLPRSS_Val) {
            object.__VersionInfo = {KLPRSS_Mnd:false, KLPRSS_Val:[1,1]};
        }
        item.__VersionInfo = {KLPRSS_Mnd:false, KLPRSS_Val:[1,5]};
    }
    hlp.ItemToLocalSettings(changedData);
    settCache.TrustedZoneSettings.ExclutionRules = changedData.ExclutionRules;
}

module.exports = {
    sections,
    toView,
    toRaw
};
