const lo = require('lodash');
const hlp = require('../../../../helpers')

const sections = ['ProductPermissionSettings']
const formValues = ['UserRights']

function toView (settCache, activePolicyCache) {
    let data = hlp.localSettingsToView(settCache.ProductPermissionSettings,activePolicyCache.ProductPermissionSettings,formValues);
    data.sddl = Buffer.from(data.UserRights.KLPRSS_Val[0]).toString()
    data.LocalSettings=true
    return data
}

function toRaw (changedData, settCache) {
    hlp.ItemToLocalSettings(changedData);
    changedData.UserRights = Buffer.from(changedData.sddl, 'utf-8')
    delete changedData.sddl
    Object.assign(settCache.ProductPermissionSettings, lo.pick(changedData, formValues))
}

module.exports = {
    sections,
    toView,
    toRaw
};
