const buffer = require('buffer');


function getPswdrData(pswrd) {
    let bytes = Buffer.from(pswrd + String.fromCharCode(0), 'utf-8');
    let bufStr16 = buffer.transcode(bytes, 'utf8', 'utf16le');
    return bufStr16.toString('base64');
}

function ItemToLocalSettings(item) {
    if(Array.isArray(item)) {
        return item.map(function(node) { return ItemToLocalSettings(node); });
    }

    Object.keys(item).forEach(property => {
        if(item[property].KLPRSS_Val!==undefined){
            if(property==='__VersionInfo'){
                item[property] = item[property].KLPRSS_Val;
            }
            else{
                let val = item[property].KLPRSS_Val;
                if(Array.isArray(val) && item[property].KLPRSS_Val[0]!== undefined){
                    val = item[property].KLPRSS_Val[0];
                }
                item[property] = (typeof val === 'object') ? ItemToLocalSettings(val) : val;
            }
        }
    })
    return item;
}

module.exports = {
    getPswdrData,
    ItemToLocalSettings
}