const DummyBlob = {type:"binary",value:''};

function defaultBlSettings() {
    return  {
        AutoStartTrayIconApplication: true,
        BasesOutdateThresholdCritical:14,
        BasesOutdateThresholdWarning:7,
        CpuUsageThreshold:20,
        CrashDumpFolder:'',
        CreateCrashDump:false,
        CriticalAreasScanOutdateThreshold:30,
        DontStartTasksIfNoSupply:true,
        EnableTrace:false,
        FileSystemUsageThreshold:35,
        FullscanOutdateThreshold:30,
        QBSizeCheckPeriod:1440,
        RtpSelfRecoveryAttempts:10,
        ScalabilityLowPriorityProcessCount:1,
        ScalabilityProcessCount:1,
        ScalabilityProcessCountUsedByRtp:1,
        SelfRecoveryAttempts:2,
        StopScansIfNoSupply:true,
        TraceFileMaxSize:50,
        TraceFolder:'',
        TraceMode:1,
        TraceSeverityLevel:5,
        TraceSubsystems:'*',
        UseAutoScalability:true,
        UseCpuUsageThreshold:false,
        UseFileSystemUsageThreshold:false,
        UseNagentAsActivationProxy:false,
        UseRtpSelfRecovery:true,
        UseSelfRecovery:true,
        _VersionInfo:[2,2]
    }
}

function defaultConnectionSettings() {
    return {ConnectionOptions:{
            BypassLocalAddresses:false,
            CacheErrorResolvingTimeout:3000,
            CacheTimeout:5000,
            DefaultProxy:{
                ProxyAuth:{AuthPassword:DummyBlob,AuthType:0,AuthUser:'',_VersionInfo:[1,0]},
                ProxyAuthType:1,
                ProxyPort:8080,
                ProxyServer:'',
                _VersionInfo:[1,0]
            },
            ProxyUsage:0,
            UseIESettings:false,
            _VersionInfo:[1,0]
        },
        _VersionInfo:[1,0]
    }
}

function defaultMountDeviceSettings() {
    return {
    ScanUsbDrive:{
        Enabled:false,
        ProtectionLevel:1,
        SizeLimit:1024,
        UseSizeLimit:true,
        _VersionInfo:[1,0]
    },
    WiFiNetwork:{
        BlockAll:false,
        ExceptionList:[],
        UseExceptionList:false,
        _VersionInfo:[1,0]
    },
    _VersionInfo:[1,1]
    }
}

function defaultReportingEventSettings(severity) {
    return {CustomEvents: [], EventSeverity: severity, UseCustomEvents: false, __VersionInfo: [1, 0]};
}

function defaultReportingSettings() {
    return {
        AVRestServerEventsStoreSettings: defaultReportingEventSettings(2),
        AntiCryptorEventsStoreSettings: defaultReportingEventSettings(2),
        ApplicationControlEventsStoreSettings: defaultReportingEventSettings(2),
        BLEventsStoreSettings: defaultReportingEventSettings(4),
        BackupEventsStoreSettings: defaultReportingEventSettings(2),
        DeviceControlEventsStoreSettings: defaultReportingEventSettings(3),
        DeviceRuleGeneratorEventsStoreSettings: defaultReportingEventSettings(4),
        ExploitBlockerEventsStoreSettings: defaultReportingEventSettings(1),
        FileIntegrityMonitorEventsStoreSettings: defaultReportingEventSettings(1),
        FileMonitorEventsStoreSettings: defaultReportingEventSettings(2),
        FirewallEventsStoreSettings: defaultReportingEventSettings(1),
        HBEventsStoreSettings: defaultReportingEventSettings(3),
        HostBlockerEventsStoreSettings: defaultReportingEventSettings(3),
        ICAPScannerEventsStoreSettings: defaultReportingEventSettings(2),
        KsnServiceEventsStoreSettings: defaultReportingEventSettings(1),
        LogInspectorEventsStoreSettings: defaultReportingEventSettings(2),
        MailTMEventsStoreSettings: defaultReportingEventSettings(2),
        NetAppAntiCryptorEventsStoreSettings: defaultReportingEventSettings(3),
        NetAppMonitorEventsStoreSettings: defaultReportingEventSettings(2),
        OdsEventsStoreSettings: defaultReportingEventSettings(2),
        PlcCheckEventsStoreSettings: defaultReportingEventSettings(4),
        PlcInvestigateEventsStoreSettings: defaultReportingEventSettings(4),
        QuarantineEventsStoreSettings: defaultReportingEventSettings(2),
        RuleGeneratorEventsStoreSettings: defaultReportingEventSettings(2),
        SCEventsStoreSettings: defaultReportingEventSettings(2),
        UpdateEventsStoreSettings: defaultReportingEventSettings(3),
        WebTMEventsStoreSettings: defaultReportingEventSettings(2),
        WiFiControlEventsStoreSettings: defaultReportingEventSettings(4),
        CheckFilesIntegrityEventsStoreSettings: defaultReportingEventSettings(4),
        AuditStorePeriod:60,
        JournalsStoreFolder:'%ESSAPPDATA%\\Reports\\',
        SyslogSettings:{
            MsgFormat:1,
            Protocol:6,
            SyslogServer:'127.0.0.1',
            SyslogServerMirror:'127.0.0.1',
            SyslogServerMirrorPort:514,
            SyslogServerPort:514,
            UsePing:false,
            UseSyslogMirrorServer:false,
            __VersionInfo:[1,0]
    },
    TaskJournalsStorePeriod:30,
    UseAuditStorePeriod:false,
    UseOnlySyslog:false,
    UseSyslog:false,
    UseTaskJournalsStorePeriod:true,
    __VersionInfo:[1,0]
    };
}

const settCommonData = {
    Defaults: {
        BackupSettings: {
            CheckFreeSpaceThreshold:true,
            CheckSizeLimit:false,
            FreeSpaceThreshold:50,
            RestorePath:'C:\\ProgramData\\Kaspersky Lab\\Kaspersky Security for Windows Server\\10.1\\Restored\\',
            SizeLimit:200,
            StorePath:'C:\\ProgramData\\Kaspersky Lab\\Kaspersky Security for Windows Server\\10.1\\Backup\\',
            _VersionInfo:[1,0]
        },
        BLSettings: defaultBlSettings(),
        ConnectionSettings: defaultConnectionSettings(),
        ExploitBlockerSettings:{

        },
        HostBlockingSettings: {
            AttemptsThreshold:200,
            AutoBlockEnabled: true,
            AutoBlockPeriod:1530,
            CheckExcludeList:false,
            Enabled:false,
            ExcludeHostsList:[],
            ExecActionCommandLine:'',
            ExecActionEnabled:false,
            ExecActionImpersonationLogin: '',
            ExecActionImpersonationPassword: DummyBlob,
            IncreaseFileMonitorLevel:false,
            IncreaseFileMonitorLevelBlockedHostsThreshold:25,
            RestoreFileMonitorLevel:true,
            RestoreFileMonitorLevelBlockedHostsThreshold:15,
            _VersionInfo:[1,0]
        },
        MountDeviceSettings: defaultMountDeviceSettings(),
        NetworkLists: { B_LIST_FLAG:0, Q_LIST_FLAG:0  },
        NotificationSettings: {},
        PasswordSettings: {},
        ProductPermissionSettings:{},
        ReportingSettings:defaultReportingSettings(),
        QuarantineSettings: {
            CheckFreeSpaceThreshold:true,
            CheckSizeLimit:false,
            FreeSpaceThreshold:50,
            RestorePath:'C:\\ProgramData\\Kaspersky Lab\\Kaspersky Security for Windows Server\\10.1\\Restored\\',
            SizeLimit:200,
            StorePath:'C:\\ProgramData\\Kaspersky Lab\\Kaspersky Security for Windows Server\\10.1\\Quarantine\\',
            _VersionInfo:[1,0]
        },
        TrustedZoneSettings:{}
    },
    PolicyMappper:{
        BackupSettings:"BackupPolicy",
        BLSettings: "BLPolicy",
        ConnectionSettings: "ConnectionPolicy",
        ExploitBlockerSettings: "ExploitBlockerPolicy",
        HostBlockingSettings: "HostBlockingPolicy",
        MountDeviceSettings: "MountDevicePolicy",
        NetworkLists: "NetworkLists",
        NotificationSettings: "NotificationPolicy",
        PasswordSettings: "PasswordPolicy",
        ProductPermissionSettings: "ProductPermissionPolicy",
        QuarantineSettings:"QuarantinePolicy",
        ReportingSettings: "ReportingPolicy",
        TrustedZoneSettings: "TrustedZonePolicy"
    }
}

module.exports = settCommonData